/* $Id: interp.h,v 1.4 2008/08/23 14:29:42 mit-sato Exp $ */

#ifndef __INTERP__
#define __INTERP__

#include <t_gc.h>
#include "types.h"
#include "hash.h"

Toy_Interp*	new_interp(char* name, int stack_size);
Toy_Interp*	interp_setup(Toy_Interp* interp, int argc, char** argv, char** envp);
int		toy_add_class(Toy_Interp* interp, char* name, Hash *slot, Toy_Type *delegate) ;
void		toy_add_func(Toy_Interp* interp,
			     char* name,
			     Toy_Type* native(Toy_Interp* interp, Toy_Type* posargs,
					      Hash* nameargs, int arglen),
			     char* argspec);
void		toy_add_method(Toy_Interp* interp,
			       char* class,
			       char* method,
			       Toy_Type* native(Toy_Interp* interp, Toy_Type* posargs,
						Hash* nameargs, int arglen),
			       char* argspec);

Toy_Obj_Env*	toy_new_obj_env(Toy_Interp* interp, Toy_Type *cur_object, Toy_Type *self);
int		toy_push_obj_new_env(Toy_Interp* interp, char* class, Toy_Type* self);
int		toy_push_obj_env(Toy_Interp* interp, Toy_Obj_Env *env);
Toy_Obj_Env*	toy_pop_obj_env(Toy_Interp* interp);

int		toy_push_func_env(Toy_Interp* interp, Hash *localvar, Hash *closurevar);
Toy_Func_Env*	toy_pop_func_env(Toy_Interp* interp);

Toy_Env*	new_closure_env(Toy_Interp* interp);

char*		get_stack_trace(Toy_Interp* interp, Cell* stack);

#endif /* __INTERP__ */
